set FitsRowViewer(first) 1

proc FitsRowViewer:Init {} {

    global FitsRowViewer
    global env
	
    if {$FitsRowViewer(first)==1} {
	package require Tk
	wm withdraw .
	uplevel #0 "source [file join $env(DRCONTROL_DIR) tclGraph.tcl]"
    }
	
    set FitsRowViewer(first) 0
}

proc FitsRowViewer:ViewRow {fitsfile row} {

    global tcl_interactive
    
    FitsRowViewer:Init
	
    set tmpfile temp_fitsrow.dat
    FitsOps:DumpRow $fitsfile $row $tmpfile
    tclGraph:OpenGraph $tmpfile
    if {$tcl_interactive==0} {
	tkwait window .
    }
}

proc FitsOps:ViewRow {fitsfile row} {

    global tcl_version
	
    if {$tcl_version<8.4} {
	puts "tcl version in use = $tcl_version"
	puts "Must have at least 8.4 for this feature!"
	return
    }
    
    FitsRowViewer:ViewRow $fitsfile $row
}
