#define USE_INTERP_RESULT 1
#include <tcl.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>





/*   -------------    START HEADER FILE CONTENTS  ------------------         */

/* Cruise control build fails on fitsprep because it cannot find
   pgplot.h or pgplot_tcl.h whereas building manually can. So as a
   temporary measure I am pasting all the header data here (mnb) */

int pgcentCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);
int PgDemo1Cmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);
int GrexecCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);
int pgopenCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);
int pgclosCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);
int pglineCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);
int pgenvCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);
int pgsvpCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);
int pgqvpCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);
int pgqwinCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);
int pgswinCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);
int pglabCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);
int pggrayCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);
int pggraylistCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);
int pgscrCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);
int pgboxCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);              
int pgbinCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);               
int pgcontCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);              
int pgdrawCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);              
int pghistCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);
int pgmoveCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);
int pgmtxtCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);
int pgpixlCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);
int pgptCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);
int pgptxtCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);
int pgqchCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);
int pgqciCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);
int pgqcolCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);
int pgscfCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);
int pgsciCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);
int pgslsCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);
int pgslwCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);
int pgsubpCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);
int pgtextCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);
int pgvsizCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);
int pgwnadCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);



int Grexec_Init(Tcl_Interp *interp);

int fortran_cmd_(int* n);



/* nswc routines most commonly used */
void ishell_(int* a,  int* n);
void  shell_(float* a,int* n);
void qsorti_(int* a,int* idx,int* n);


int  pgopen_wrapper_();
int  pgopen_(char* device,unsigned long l);
void pgclos_();
void pgenv_(float* xmin, float* xmax, float* ymin, float* ymax, int* n1, int* n2);
void pgline_(int* n, float* xpts, float* ypts);
void pgsvp_(float* x1, float* x2, float* y3, float* y2);
void pgqvp_(int* units, float* x1, float* x2, float* y3, float* y2);
void pgswin_(float* x1, float* x2, float* y1, float* y2);
void pgqwin_(float* x1, float* x2, float* y3, float* y2);
void pglab_(char* s1,char* s2,char* s3,unsigned long l1,unsigned long l2,unsigned long l3);
void pggray_(float* a,int* idim,int* jdim,int* i1,int* i2,int* j1,int* j2,float* fg, float* bg,float* tr);
void pgvstd_();
void pgscr_(int* i,float* x1,float*x2,float*x3);
void pgbox_(char *xopt,float *xtick,int *nxsub,char *yopt,float *ytick,int *nysub,unsigned long l1,unsigned long l2);
void pgbin_(int* i, float* x, float* d, int* l);
void pgcont_(float* a,int* idim,int* jdim,int* i1,int* i2,int* j1,int* j2,float* cont,int* nconts,float* tr);
void pgdraw_(float* x,float* y);
void pghist_(int* n, float* data, float* datamin,float*datamax,int* nbin, int* pgflag);
void pgmove_(float* x,float* y);
void pgmtxt_(char* side,float* disp,float* coord,float* fjust,char* txt,unsigned long l1,unsigned long l5);
void pgpixl_(float* a,int* idim,int* jdim,int* i1,int* i2,int* j1,int* j2,float* x1, float* x2, float* y1, float* y2);
void pgpt_(int* n, float* xpts, float* ypts,int* i);
void pgptxt_(float* x,float* y,float* a,float* f,char* txt,unsigned long l5);
void pgqch_();
void pgqci_();
void pgqcol_();
void pgscf_(int* i);
void pgsci_(int* i);
void pgsls_(int* i);
void pgslw_(int* i);
void pgsubp_(int* i1, int* i2);
void pgtext_(float* x,float* y,char* txt,unsigned long l3);
void pgvsiz_(float* x1,float* x2,float* x3,float* x4);
void pgwnad_(float* x1,float* x2,float* x3,float* x4);
int  lmergeCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);
int  ptr2dataCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);

/*   -------------    END HEADER FILE CONTENTS  ------------------         */

/*---------------------------------------------------------------------*/


/* -----------------------------------------------------------------------*/
/*                           lmergeCmd                                    */
/* -----------------------------------------------------------------------*/

/*          An extension to the tcl list commands. 

Will input 2 lists eg.

	list1= {a b c d} and list2={1 2 3 4}
        
 and will create a new list that is a merger of the two in alternate 
 sequence, eg,
 
 lmerge $list1 $list2 = {a 1 b 2 c 3 d 4}

*/
int lmergeCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[])
{
    int list1Rc, list2Rc;
    const char **list1Rv,**list2Rv;
    int i;
    
    if (argc<2) return TCL_ERROR;
    
    /* Split the first List of Double Value Strings values*/
    if (Tcl_SplitList(interp, argv[1], &list1Rc, &list1Rv) != TCL_OK) {
       return TCL_ERROR;
    };

    /* Split the second List of Double Value Strings values*/
    if (Tcl_SplitList(interp, argv[2], &list2Rc, &list2Rv) != TCL_OK) {
       return TCL_ERROR;
    };
    
    if (list1Rc!=list2Rc) {return TCL_ERROR;}

    /* Define return value as a merger of the two lists*/
    for (i=0;i<list1Rc;i++) 
    {
       Tcl_AppendElement(interp,list1Rv[i]);
       Tcl_AppendElement(interp,list2Rv[i]);

    }


    return TCL_OK;

}


/* -----------------------------------------------------------------------*/
/*                          ptr2dataCmd                                   */
/* -----------------------------------------------------------------------*/
/* An extension to the fitstcl ptr2lst command in that it will return     */
/* data values direct from memory in a miriad of options                  */
/*
	ptr2data dat  [row] [col]	Return value of cell
	ptr2data col  [col]	        Return entire column as a tcl list
	ptr2data row  [row]      	Return entire row as a tcl list
	ptr2data ri   [row]             Return entire row as an indexed list
	ptr2data ci   [col]		Return entire col as an indexed list
	ptr2data sr   [row] [col1] [col2] Return sum of row from col1 to col2
	ptr2data mr   [row] [col1] [col2] Return median of row from col1 to col2


Note: cnvtForFitsNan is a temporary hack as we do not know what represents the
nan values at this stage.
*/

float cnvtForFitsNan(float *gf) 
{

    float f;
    f=*gf;

    if (isnan(f)) {f=0.0;}
    if (isinf(f)) {f=0.0;}
    if (f> 8000000.0) {f=0.0;}
    if (f<-1000000.0) {f=0.0;}
    *gf=f;

}


int ptr2dataCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[])
{

    void *theptr;
    float f;
    float fv[10];
    int i;
    float sum, median;
    int col1,col2, n, idx;
    float *sortV;
    int *idxV;
    
    int nrows,ncols;
    int req_i,req_j,req_row,req_col;
    char buffer[100];
    
   union {
      unsigned char  *byte;
      short          *shrt;
      int            *lng;
      float          *flt;
      double         *dbl;
      void           *ptr;
   } ptrs;
   
    /* Must have at least 5 arguments ptr string, ncols and nrows*/
    if (argc<=5) return TCL_ERROR;
    
    /*Translate ptr string into a pointer we can use (see fitstcl guide)*/
    sscanf(argv[2],"%p",&theptr);
    
    /* Get the array size*/
    Tcl_GetInt(interp,argv[3],&ncols);
    Tcl_GetInt(interp,argv[4],&nrows);    


    /* Switch on choice if the argv[1] string*/
    if (argv[1][0]=='r') {
    
        /* Return row data as tcl list*/
        
        Tcl_GetInt(interp,argv[5],&req_row);

        idx=(req_row-1)*ncols;
        ptrs.ptr=theptr;
        ptrs.ptr=ptrs.ptr+idx*sizeof(float);
            
        for( i=0; i<ncols; i++) {

            /*If arg[1] is "ri" then add row index first*/
            if (argv[1][1]=='i') {
                sprintf(buffer,"%f",(float)(i+1));
                Tcl_AppendElement(interp,buffer);
            } 

            f=(float)*ptrs.flt;
            cnvtForFitsNan(&f);
            sprintf(buffer,"%f",f);
            Tcl_AppendElement(interp,buffer);

            ptrs.flt++ ;
        }    

        return TCL_OK;
        
     } else if (argv[1][0]=='s') {
     
        /* Return summation of row data. Must have 7 args*/

        if (argc<=7) return TCL_ERROR;

        Tcl_GetInt(interp,argv[5],&req_row);
        Tcl_GetInt(interp,argv[6],&col1);
        Tcl_GetInt(interp,argv[7],&col2);

        if (col1<1) col1=1;
        if (col2>ncols) col2=ncols;

        idx=(req_row-1)*ncols;
        ptrs.ptr=theptr;
        ptrs.ptr=ptrs.ptr+idx*sizeof(float);
        
        sum=0.0;    
        for( i=col1-1; i<col2; i++) {

            f=(float)*ptrs.flt;
            cnvtForFitsNan(&f);
            sum=sum+f;
            ptrs.flt++ ;
        }    
    
        sprintf(interp->result,"%f",sum);

        return TCL_OK;
        
      } else if (argv[1][0]=='m') {
      
        /* Return median of row data. Must have 7 args*/

        if (argc<=7) return TCL_ERROR;
      
        Tcl_GetInt(interp,argv[5],&req_row);
        Tcl_GetInt(interp,argv[6],&col1);
        Tcl_GetInt(interp,argv[7],&col2);
        if (col1<1) col1=1;
        if (col2>ncols) col2=ncols;

        idx=(req_row-1)*ncols;
        ptrs.ptr=theptr;
        ptrs.ptr=ptrs.ptr+idx*sizeof(float);
 
        n=col2-col1+1;

        sortV=malloc(n*sizeof(float));

        idx=0;
        for( i=col1-1; i<col2; i++) {

            f=(float)*ptrs.flt;
            cnvtForFitsNan(&f);
            sortV[idx]=f;
            idx=idx+1;
            ptrs.flt++ ;
            
        }    
    
        n=idx;

        shell_(sortV,&n);
        idx=(int)(0.5*n);
        median=sortV[idx];
    
        sprintf(interp->result,"%f",median);

        return TCL_OK;
        
        
   } else if (argv[1][0]=='c') {
   
        /* Return col data as tcl list*/

        Tcl_GetInt(interp,argv[5],&req_col);

        idx=(req_col-1);
        ptrs.ptr=theptr;
        ptrs.ptr=ptrs.ptr+idx*sizeof(float);
            
        for( i=0; i<nrows; i++) {

            f=(float)*ptrs.flt;
            sprintf(buffer,"%f",f);
            Tcl_AppendElement(interp,buffer);
            
            /*If arg[1] is "ci" then add col index as well*/
            if (argv[1][1]=='i') {
                sprintf(buffer,"%f",(float)(i+1));
                Tcl_AppendElement(interp,buffer);
            } 

            ptrs.ptr=ptrs.ptr+ncols*sizeof(float);
        }    
        
        return TCL_OK;

    }

    /* Default return the data value of specified cell. Must have 6 args*/    

    if (argc<=6) return TCL_ERROR;

    Tcl_GetInt(interp,argv[5],&req_i);
    Tcl_GetInt(interp,argv[6],&req_j);    

    idx=(req_i-1)*ncols+(req_j-1);
    ptrs.ptr=theptr;
    ptrs.ptr=ptrs.ptr+idx*sizeof(float);    
    f=(float)*ptrs.flt;
    sprintf(interp->result,"%f",f);

    return TCL_OK;


}


/*---------------------------------------------------------------------*/
/*---------------------------------------------------------------------*/

/*                  Tcl Wrappers to pgplot commands                   */

/*---------------------------------------------------------------------*/
/*---------------------------------------------------------------------*/

int GrexecCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[])
{
    int idev,ifunc,nbuf,lchr;
    float * rbuf_ptr;
    char  * chr_ptr;
    
    int listRc;
    const char **listRv;
    double d;
    int i;
    
    /* Sanity check that there are at least 6 arguments */
    if (argc<7) return TCL_ERROR;
    
    /* Extract the integer arguments */
    Tcl_GetInt(interp,argv[1],&idev);
    Tcl_GetInt(interp,argv[2],&ifunc);
    Tcl_GetInt(interp,argv[4],&nbuf);
    Tcl_GetInt(interp,argv[6],&lchr);

    rbuf_ptr = malloc (nbuf * sizeof (float));
    chr_ptr  = malloc ((lchr+3) * sizeof (char));
    
    /* Copy the string argument into the chr buffer */
    strcpy(chr_ptr,argv[5]);

    /* Split the List of Double Value Strings into Rbuffer vector*/
    if (Tcl_SplitList(interp, argv[3], &listRc, &listRv) != TCL_OK) {
        free(rbuf_ptr);
        free(chr_ptr);
        return TCL_ERROR;
    };
    for (i=0;i<listRc;i++) 
    {
        Tcl_GetDouble(interp,listRv[i],&d);
        rbuf_ptr[i]=(float)d;
    }

    /* Now call the grexec command*/
    /*grexec2_(&idev,&ifunc,rbuf_ptr,&nbuf,chr_ptr,&lchr);*/

    free(rbuf_ptr);
    free(chr_ptr);
    return TCL_OK;

}

/*---------------------------------------------------------------------*/

int  pgopenCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[])
{
    int status;
    unsigned long lstr;
   
    lstr=(unsigned long)strlen(argv[1]);

    /* Copy the string argument into the chr buffer */
    status=pgopen_(argv[1],lstr);

    return TCL_OK;
}
/*---------------------------------------------------------------------*/

int  pgclosCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[])
{
    pgclos_();
    return TCL_OK;
}
/*---------------------------------------------------------------------*/

int  pglineCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[])
{
    int n;
    float* xpts_ptr;
    float* ypts_ptr;
    int listDc;
    const char **listDv;
    double d;
    int i;
    
    if (argc<=3) return TCL_ERROR;

    /* Get the number of points */
    Tcl_GetInt(interp,argv[1],&n);
    
    xpts_ptr=malloc (n * sizeof (float));
    ypts_ptr=malloc (n * sizeof (float));
    
    /* Split the List of Double Value Strings into xpts vector*/
    if (Tcl_SplitList(interp, argv[2], &listDc, &listDv) != TCL_OK) {
        free(xpts_ptr);
        free(ypts_ptr);
        return TCL_ERROR;
    };
    if (listDc!=n) {
        free(xpts_ptr);
        free(ypts_ptr);
    	return TCL_ERROR;
    };
    
    for (i=0;i<listDc;i++) 
    {
        Tcl_GetDouble(interp,listDv[i],&d);
        xpts_ptr[i]=(float)d;
    }

    /* Split the List of Double Value Strings into ypts vector*/
    if (Tcl_SplitList(interp, argv[3], &listDc, &listDv) != TCL_OK) {
        free(xpts_ptr);
        free(ypts_ptr);
        return TCL_ERROR;
    };
    for (i=0;i<listDc;i++) 
    {
        Tcl_GetDouble(interp,listDv[i],&d);
        ypts_ptr[i]=(float)d;
    }
    
    pgline_(&n,xpts_ptr,ypts_ptr);

    free(xpts_ptr);
    free(ypts_ptr);
    return TCL_OK;
}
/*---------------------------------------------------------------------*/

int  pgenvCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[])
{
    float xmin,xmax,ymin,ymax;
    double dxmin,dxmax,dymin,dymax;
    int n1,n2;
    
    Tcl_GetDouble(interp,argv[1],&dxmin);
    Tcl_GetDouble(interp,argv[2],&dxmax);
    Tcl_GetDouble(interp,argv[3],&dymin);
    Tcl_GetDouble(interp,argv[4],&dymax);
    Tcl_GetInt(interp,argv[5],&n1);
    Tcl_GetInt(interp,argv[6],&n2);
    xmin=(float)dxmin;
    xmax=(float)dxmax;
    ymin=(float)dymin;
    ymax=(float)dymax;
    pgenv_(&xmin,&xmax,&ymin,&ymax,&n1,&n2);
    return TCL_OK;

}
              
/*---------------------------------------------------------------------*/

int  pgsvpCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[])
{
    float x1,x2,y1,y2;
    double d;
    
    if (argc<=4) {return TCL_ERROR;}
    
    Tcl_GetDouble(interp,argv[1],&d);
    x1=(float)d;
    Tcl_GetDouble(interp,argv[2],&d);
    x2=(float)d;
    Tcl_GetDouble(interp,argv[3],&d);
    y1=(float)d;
    Tcl_GetDouble(interp,argv[4],&d);
    y2=(float)d;

    pgsvp_(&x1,&x2,&y1,&y2);

    return TCL_OK;

}
              
/*---------------------------------------------------------------------*/

int  pgqvpCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[])
{
    int n;
    float x1,x2,y1,y2;    
    
    Tcl_GetInt(interp,argv[1],&n);

    pgqvp_(&n,&x1,&x2,&y1,&y2);
    sprintf(interp->result,"%f %f %f %f",x1,x2,y1,y2);

    return TCL_OK;

}
              
/*---------------------------------------------------------------------*/

int  pgqwinCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[])
{
    float x1,x2,y1,y2;

    pgqwin_(&x1,&x2,&y1,&y2);
    sprintf(interp->result,"%f %f %f %f",x1,x2,y1,y2);

    return TCL_OK;

}
              
/*---------------------------------------------------------------------*/

int  pgswinCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[])
{
    float x1,x2,y1,y2;
    double d;
    
    if (argc<=4) {return TCL_ERROR;}
    
    Tcl_GetDouble(interp,argv[1],&d);
    x1=(float)d;
    Tcl_GetDouble(interp,argv[2],&d);
    x2=(float)d;
    Tcl_GetDouble(interp,argv[3],&d);
    y1=(float)d;
    Tcl_GetDouble(interp,argv[4],&d);
    y2=(float)d;

    pgswin_(&x1,&x2,&y1,&y2);

    return TCL_OK;

}
              
/*---------------------------------------------------------------------*/

int  pglabCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[])
{
    unsigned long l1,l2,l3;
    
    if (argc<=3) {return TCL_ERROR;}
    
    l1=(unsigned long)strlen(argv[1]);
    l2=(unsigned long)strlen(argv[2]);
    l3=(unsigned long)strlen(argv[3]);

    pglab_(argv[1],argv[2],argv[3],l1,l2,l3);

    return TCL_OK;

}

/*---------------------------------------------------------------------*/

int  pgscrCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[])
{
    int i;
    double d;
    float x1,x2,x3;
    
    if (argc<=3) {return TCL_ERROR;}
        
    Tcl_GetInt(interp,argv[1],&i);
    Tcl_GetDouble(interp,argv[2],&d);
    x1=(float)d;
    Tcl_GetDouble(interp,argv[3],&d);
    x2=(float)d;
    Tcl_GetDouble(interp,argv[3],&d);
    x3=(float)d;

    pgscr_(&i,&x1,&x2,&x3);

    return TCL_OK;

}


/*---------------------------------------------------------------------*/

int  pgboxCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[])
{

    int nxsub,nysub;
    float xtick,ytick;
    double d;
    unsigned long l1,l2;

    if (argc<=6) {return TCL_ERROR;}

    Tcl_GetDouble(interp,argv[2],&d);
    xtick=(float) d;
    Tcl_GetInt(interp,argv[3],&nxsub);
    Tcl_GetDouble(interp,argv[5],&d);
    ytick=(float) d;
    Tcl_GetInt(interp,argv[6],&nysub);

    l1=(unsigned long)strlen(argv[1]);
    l2=(unsigned long)strlen(argv[4]);

    pgbox_(argv[1],&xtick,&nxsub,argv[4],&ytick,&nysub,l1,l2);

    return TCL_OK;

}
/*---------------------------------------------------------------------*/

int  pggrayCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[])
{

    int dimi,dimj,i1,i2,j1,j2;
    float fg,bg,tr[5];
    
    int size,i;
    int listDc;
    const char **listDv;
    double d;
    void* floatData;

    if (argc<=9) {return TCL_ERROR;}

    sscanf(argv[1], "%p", &floatData);
    
    Tcl_GetInt(interp,argv[2],&dimi);
    Tcl_GetInt(interp,argv[3],&dimj);
    Tcl_GetInt(interp,argv[4],&i1);
    Tcl_GetInt(interp,argv[5],&i2);
    Tcl_GetInt(interp,argv[6],&j1);
    Tcl_GetInt(interp,argv[7],&j2);
    Tcl_GetDouble(interp,argv[8],&d);
    fg=(float)d;
    Tcl_GetDouble(interp,argv[9],&d);
    bg=(float)d;
    
    size=dimi*dimj;


    /* Split the List of Double Value Strings*/
    if (Tcl_SplitList(interp, argv[10], &listDc, &listDv) != TCL_OK) {
        return TCL_ERROR;
    }
    
    if (listDc<=5) {return TCL_ERROR;}
    for (i=0; i<=5;i++) {
        Tcl_GetDouble(interp,listDv[i],&d);
        tr[i]=(float)d;
    }

    pggray_(floatData,&dimi,&dimj,&i1,&i2,&j1,&j2,&fg,&bg,tr);

    return TCL_OK;

}

/*---------------------------------------------------------------------*/

int  pggraylistCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[])
{

    int dimi,dimj,i1,i2,j1,j2;
    float tr[5];
    float* aptr;
    
    int size,idx,i,j;
    int listDc;
    const char **listDv;
    double d;
    float fg,bg;
    double* dptr;

    if (argc<=9) {return TCL_ERROR;}

    
    Tcl_GetInt(interp,argv[2],&dimi);
    Tcl_GetInt(interp,argv[3],&dimj);
    Tcl_GetInt(interp,argv[4],&i1);
    Tcl_GetInt(interp,argv[5],&i2);
    Tcl_GetInt(interp,argv[6],&j1);
    Tcl_GetInt(interp,argv[7],&j2);
    Tcl_GetDouble(interp,argv[8],&d);
    fg=(float)d;
    Tcl_GetDouble(interp,argv[9],&d);
    bg=(float)d;
    
    size=dimi*dimj;
    
    /* Split the List of Double Value Strings from argv[1]*/
    if (Tcl_SplitList(interp, argv[1], &listDc, &listDv) != TCL_OK) {
       return TCL_ERROR;
    }
    
    /* Convert list doubles into a c vector*/
    dptr=malloc(size*sizeof(double));
    aptr= malloc(size*sizeof(float));
    idx=0;
    for (idx=0; idx<size;idx++) {
         Tcl_GetDouble(interp,listDv[idx],&dptr[idx]);
    }
    
    /* Convert c double array into a fortran real array */
    idx=0;
    for (j=0; j<dimj;j++) {
        for (i=0; i<dimi;i++) {
           aptr[idx]=(float)dptr[idx];
           idx++;
        }
    }
       
    /* Split the List of Double Value Strings*/
    if (Tcl_SplitList(interp, argv[10], &listDc, &listDv) != TCL_OK) {
        free(dptr);
        free(aptr);
        return TCL_ERROR;
    }
    for (i=0; i<=5;i++) {
        Tcl_GetDouble(interp,listDv[i],&d);
        tr[i]=(float)d;
    }
    
    
    pggray_(aptr,&dimi,&dimj,&i1,&i2,&j1,&j2,&fg,&bg,tr);
    
    free(aptr);
    free(dptr);
    
    return TCL_OK;

}


/*---------------------------------------------------------------------*/
/* Tcl command to obtain the low and high 5 percentiles of the data range
of image data that has been loaded into memory via fitstcl load command.
Input is the fitstcl ptr string and data size. Optional extra is a char 'q'
to indicate use a quick and dirty method.
Return the two values a a pair list */

int pgcentCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[])
{ 
    int n;
    int i; 
    float* floatData;
    int* sortV;
    float* sortfV;
    int* idxV;
    float xlo,xhi;
    int ilo,ihi;
    int quick_flag;

   /* There must be at least 2 arguments*/
    if (argc<=2) {return TCL_ERROR;}

    /* If there is an extra argument ="q" then perform quick and dirty
    calculation */
    quick_flag=0;
    if (argc>3) {
       /* there is an extra argument. check if it begins with "q"*/
       if (argv[3][0]=='q') quick_flag=1;
    }

    /* Get the pointer string and convert into a useable pointer (see fitstcl
    guide)*/
    sscanf(argv[1], "%p", &floatData);

    /* Get the data size*/
    Tcl_GetInt(interp,argv[2],&n); 

    if (quick_flag==1) {

       /* Quick and dirty option we sort integer values using nswc qsorti*/
        sortV=malloc(n*sizeof(int));
        idxV =malloc(n*sizeof(int));
        for (i=0;i<n;i++) {
          sortV[i]=(int)floatData[i];
          idxV[i]=i+1;
        }

        qsorti_(sortV,idxV,&n);

        ilo=(int)(0.05*n);
        ihi=(int)(0.95*n);
        ilo=idxV[ilo];
        ihi=idxV[ihi];
        xlo=sortV[ilo];
        xhi=sortV[ihi];

        free(sortV);  
        free(idxV);
          
    } else {

        /* We sort float values using nswc qsortr*/
        sortfV=malloc(n*sizeof(float));
        idxV =malloc(n*sizeof(int));
        for (i=0;i<n;i++) {
          sortfV[i]=(float)floatData[i];
          idxV[i]=i+1;
        }

        qsortr_(sortfV,idxV,&n);

        ilo=(int)(0.05*n);
        ihi=(int)(0.95*n);
        ilo=idxV[ilo];
        ihi=idxV[ihi];
        xlo=sortfV[ilo];
        xhi=sortfV[ihi];

        free(sortfV);  
        free(idxV);
          
    }
    
    /*return the two values as a list*/
    sprintf(interp->result,"%f %f",xlo,xhi);

    return TCL_OK;

}

/*---------------------------------------------------------------------*/

int pgbinCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[])
{ 
    int n, l;
    float* xpts_ptr;
    float* ypts_ptr;
    int listDc;
    const char **listDv;
    double d;
    int i;
   
    if (argc<=4) {return TCL_ERROR;}
    
    Tcl_GetInt(interp,argv[1],&n);
    
    xpts_ptr=malloc (n * sizeof (float));
    ypts_ptr=malloc (n * sizeof (float));
    
    /* Split the List of Double Value Strings into xpts vector*/
    if (Tcl_SplitList(interp, argv[2], &listDc, &listDv) != TCL_OK) {
        free(xpts_ptr);
        free(ypts_ptr);
        return TCL_ERROR;
    };
    if (listDc!=n) {
        free(xpts_ptr);
        free(ypts_ptr);
    	return TCL_ERROR;
    };
    
    for (i=0;i<listDc;i++) 
    {
        Tcl_GetDouble(interp,listDv[i],&d);
        xpts_ptr[i]=(float)d;
    }

    /* Split the List of Double Value Strings into ypts vector*/
    if (Tcl_SplitList(interp, argv[3], &listDc, &listDv) != TCL_OK) {
        free(xpts_ptr);
        free(ypts_ptr);
        return TCL_ERROR;
    };
    for (i=0;i<listDc;i++) 
    {
        Tcl_GetDouble(interp,listDv[i],&d);
        ypts_ptr[i]=(float)d;
    }
    
   /* Last argument is a logical */

    Tcl_GetInt(interp,argv[4],&l);

    /* integer l has to be translated as a set of bytes that fortran
     will read as a logical (no matter how many bits it picks up. 
     If l==0, then all memory bits are 0 and fortran will read any portion
     as a zero (logical false). If l==NOT(0) then all bits will be one and
     fortran will read any portion as non zero (logical true)*/
    if (l!=0) l= !0; 
    
    pgbin_(&n,xpts_ptr,ypts_ptr,&l);

    free(xpts_ptr);
    free(ypts_ptr);
    
    return TCL_OK;

}

/*---------------------------------------------------------------------*/

int pgcontCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[])
{    
    int dimi,dimj,i1,i2,j1,j2;
    float tr[5];
    int ncont;
    float* aptr;
    float* cont_ptr;
    
    int size,idx,i,j;
    int listDc;
    const char **listDv;
    double d;
    double* dptr;

    if (argc<=9) {return TCL_ERROR;}

    
    Tcl_GetInt(interp,argv[2],&dimi);
    Tcl_GetInt(interp,argv[3],&dimj);
    Tcl_GetInt(interp,argv[4],&i1);
    Tcl_GetInt(interp,argv[5],&i2);
    Tcl_GetInt(interp,argv[6],&j1);
    Tcl_GetInt(interp,argv[7],&j2);
    Tcl_GetInt(interp,argv[9],&ncont);
    
    size=dimi*dimj;
    
    /* Split the List of Double Value Strings from argv[1]*/
    if (Tcl_SplitList(interp, argv[1], &listDc, &listDv) != TCL_OK) {
       return TCL_ERROR;
    }
    
    /* Convert list doubles into a c vector*/
    dptr=malloc(size*sizeof(double));
    aptr= malloc(size*sizeof(float));
    idx=0;
    for (idx=0; idx<size;idx++) {
         Tcl_GetDouble(interp,listDv[idx],&dptr[idx]);
    }
    
    /* Convert c array into a fortran array vector*/
    idx=0;
    for (j=0; j<dimj;j++) {
        for (i=0; i<dimi;i++) {
           aptr[idx]=(float)dptr[idx];
           idx++;
        }
    }
       
    /* Split the List of Double Value Strings*/
    if (Tcl_SplitList(interp, argv[10], &listDc, &listDv) != TCL_OK) {
        free(dptr);
        free(aptr);
        return TCL_ERROR;
    }
    for (i=0; i<=5;i++) {
        Tcl_GetDouble(interp,listDv[i],&d);
        tr[i]=(float)d;
    }
    
    /* Split the List of Double Value Strings from argv[8]*/
    if (Tcl_SplitList(interp, argv[8], &listDc, &listDv) != TCL_OK) {
        free(dptr);
        free(aptr);
        return TCL_ERROR;
    }
    if (listDc!=ncont) {
        free(dptr);
        free(aptr);
    	return TCL_ERROR;
    };
    cont_ptr=malloc(ncont*sizeof(float));
    
    for (i=0;i<listDc;i++) 
    {
        Tcl_GetDouble(interp,listDv[i],&d);
        cont_ptr[i]=(float)d;
    }

    pgcont_(aptr,&dimi,&dimj,&i1,&i2,&j1,&j2,cont_ptr,&ncont,tr);
    
    free(aptr);
    free(dptr);
    free(cont_ptr);
    
    return TCL_OK;

}
/*---------------------------------------------------------------------*/

int pgdrawCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[])
{    
    float x,y;
    double d;

    if (argc<=2) {return TCL_ERROR;}
    
    Tcl_GetDouble(interp,argv[1],&d);
    x=(float)d;
    Tcl_GetDouble(interp,argv[2],&d);
    y=(float)d;
    
    pgdraw_(&x,&y);
    
    return TCL_OK;

}
/*---------------------------------------------------------------------*/

int pghistCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[])
{    
    int n,nbin,pgflag;
    float* data_ptr;
    float datamin,datamax;
    int listDc;
    const char **listDv;
    double d;
    int i;
    
    if (argc<=6) {return TCL_ERROR;}
    
    Tcl_GetInt(interp,argv[1],&n);
    Tcl_GetDouble(interp,argv[3],&d);
    datamin=(float)d;
    Tcl_GetDouble(interp,argv[4],&d);
    datamax=(float)d;
    Tcl_GetInt(interp,argv[5],&nbin);
    Tcl_GetInt(interp,argv[6],&pgflag);
    
    /* Split the List of Double Value Strings into xpts vector*/
    if (Tcl_SplitList(interp, argv[2], &listDc, &listDv) != TCL_OK) {
        return TCL_ERROR;
    };
    if (listDc!=n) {
    	return TCL_ERROR;
    };
    
    data_ptr=malloc (n * sizeof (float));
    
    for (i=0;i<listDc;i++) 
    {
        Tcl_GetDouble(interp,listDv[i],&d);
        data_ptr[i]=(float)d;
    }
    
    pghist_(&n,data_ptr,&datamin,&datamax,&nbin,&pgflag);
    
    free(data_ptr);
    
    return TCL_OK;

}
/*---------------------------------------------------------------------*/

int pgmoveCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[])
{    
    float x,y;
    double d;

    if (argc<=2) {return TCL_ERROR;}
    
    Tcl_GetDouble(interp,argv[1],&d);
    x=(float)d;
    Tcl_GetDouble(interp,argv[2],&d);
    y=(float)d;
    
    pgmove_(&x,&y);
    
    return TCL_OK;

}
/*---------------------------------------------------------------------*/

int pgmtxtCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[])
{    
    float disp,coord,fjust;
    double d;
    unsigned long l1,l5;
       
    if (argc<=5) {return TCL_ERROR;}

    Tcl_GetDouble(interp,argv[2],&d);
    disp=(float)d;
    Tcl_GetDouble(interp,argv[3],&d);
    coord=(float)d;
    Tcl_GetDouble(interp,argv[4],&d);
    fjust=(float)d;
    
    l1=(unsigned long)strlen(argv[1]);
    l5=(unsigned long)strlen(argv[5]);
    
    pgmtxt_(argv[1],&disp,&coord,&fjust,argv[5],l1,l5);

    return TCL_OK;

}

/*---------------------------------------------------------------------*/

int pgpixlCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[])
{    
    int dimi,dimj,i1,i2,j1,j2;
    float x1,x2,y1,y2;
    float* aptr;
    int size,idx,i,j;
    int listDc;
    const char **listDv;
    double d;
    double* dptr;

    if (argc<=11) {return TCL_ERROR;}

    
    Tcl_GetInt(interp,argv[2],&dimi);
    Tcl_GetInt(interp,argv[3],&dimj);
    Tcl_GetInt(interp,argv[4],&i1);
    Tcl_GetInt(interp,argv[5],&i2);
    Tcl_GetInt(interp,argv[6],&j1);
    Tcl_GetInt(interp,argv[7],&j2);
    Tcl_GetDouble(interp,argv[8],&d);
    x1=(float)d;
    Tcl_GetDouble(interp,argv[9],&d);
    x2=(float)d;
    Tcl_GetDouble(interp,argv[10],&d);
    y1=(float)d;
    Tcl_GetDouble(interp,argv[11],&d);
    y2=(float)d;


    size=dimi*dimj;
    
    /* Split the List of Double Value Strings from argv[1]*/
    if (Tcl_SplitList(interp, argv[1], &listDc, &listDv) != TCL_OK) {
       return TCL_ERROR;
    }
    
    /* Convert list doubles into a c vector*/
    dptr=malloc(size*sizeof(double));
    aptr= malloc(size*sizeof(float));
    idx=0;
    for (idx=0; idx<size;idx++) {
         Tcl_GetDouble(interp,listDv[idx],&dptr[idx]);
    }
    
    /* Convert c array into a fortran array vector*/
    idx=0;
    for (j=0; j<dimj;j++) {
        for (i=0; i<dimi;i++) {
           aptr[idx]=(float)dptr[(i*dimj+j)];
           idx++;
        }
    }
       

    pgpixl_(aptr,&dimi,&dimj,&i1,&i2,&j1,&j2,&x1,&x2,&y1,&y2);
    
    free(aptr);
    free(dptr);


    return TCL_OK;

}

/*---------------------------------------------------------------------*/

int pgptCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[])
{    
    int n, id;
    float* xpts_ptr;
    float* ypts_ptr;
    int listDc;
    const char **listDv;
    double d;
    int i;

    if (argc<=4) return TCL_ERROR;

    /* Get the number of points */
    Tcl_GetInt(interp,argv[1],&n);
    
    xpts_ptr=malloc (n * sizeof (float));
    ypts_ptr=malloc (n * sizeof (float));
    
    /* Split the List of Double Value Strings into xpts vector*/
    if (Tcl_SplitList(interp, argv[2], &listDc, &listDv) != TCL_OK) {
        free(xpts_ptr);
        free(ypts_ptr);
        return TCL_ERROR;
    };
    if (listDc!=n) {return TCL_ERROR;};
    
    for (i=0;i<listDc;i++) 
    {
        Tcl_GetDouble(interp,listDv[i],&d);
        xpts_ptr[i]=(float)d;
    }

    /* Split the List of Double Value Strings into ypts vector*/
    if (Tcl_SplitList(interp, argv[3], &listDc, &listDv) != TCL_OK) {
        free(xpts_ptr);
        free(ypts_ptr);
        return TCL_ERROR;
    };
    for (i=0;i<listDc;i++) 
    {
        Tcl_GetDouble(interp,listDv[i],&d);
        ypts_ptr[i]=(float)d;
    }
    
    /* Get the point type id */
    Tcl_GetInt(interp,argv[4],&id);
    
    pgpt_(&n,xpts_ptr,ypts_ptr,&id);

    free(xpts_ptr);
    free(ypts_ptr);
    return TCL_OK;

}

/*---------------------------------------------------------------------*/

int pgptxtCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[])
{    
    float x,y,a,f;
    double d;
    unsigned long l5;
       
    if (argc<=5) {return TCL_ERROR;}

    Tcl_GetDouble(interp,argv[1],&d);
    x=(float)d;
    Tcl_GetDouble(interp,argv[2],&d);
    y=(float)d;
    Tcl_GetDouble(interp,argv[3],&d);
    a=(float)d;
    Tcl_GetDouble(interp,argv[4],&d);
    f=(float)d;
    l5=(unsigned long)strlen(argv[5]);
    
    pgptxt_(&x,&y,&a,&f,argv[5],l5);

    return TCL_OK;

}
/*---------------------------------------------------------------------*/

int pgqchCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[])
{    
    float x;

    pgqch_(&x);
    
    sprintf(interp->result,"%f",x);

    return TCL_OK;

}
/*---------------------------------------------------------------------*/

int pgqciCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[])
{    
    int i;

    pgqci_(&i);
    
    sprintf(interp->result,"%d",i);

    return TCL_OK;

}
/*---------------------------------------------------------------------*/

int pgqcolCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[])
{    
    int ci1, ci2;

    pgqcol_(&ci1,&ci2);
    
    sprintf(interp->result,"%d %d",ci1,ci2);

    return TCL_OK;

}

/*---------------------------------------------------------------------*/

int pgscfCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[])
{    
    int i;
    
    if (argc<=1) {return TCL_ERROR;}
    
    Tcl_GetInt(interp,argv[1],&i);
    
    pgscf_(&i);
    
    return TCL_OK;

}
/*---------------------------------------------------------------------*/

int pgsciCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[])
{    
    int i;
        
    if (argc<=1) {return TCL_ERROR;}

    Tcl_GetInt(interp,argv[1],&i);

    pgsci_(&i);

    return TCL_OK;

}
/*---------------------------------------------------------------------*/

int pgslsCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[])
{    
    int i;
        
    if (argc<=1) {return TCL_ERROR;}

    Tcl_GetInt(interp,argv[1],&i);

    pgsls_(&i);
    
    return TCL_OK;

}
/*---------------------------------------------------------------------*/

int pgslwCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[])
{    
    int i;
        
    if (argc<=1) {return TCL_ERROR;}

    Tcl_GetInt(interp,argv[1],&i);

    pgslw_(&i);
    
    return TCL_OK;

}

/*---------------------------------------------------------------------*/

int pgsubpCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[])
{    
    int i1,i2;
        
    if (argc<=2) {return TCL_ERROR;}

    Tcl_GetInt(interp,argv[1],&i1);
    Tcl_GetInt(interp,argv[2],&i2);

    pgsubp_(&i1,&i2);
    return TCL_OK;

}
/*---------------------------------------------------------------------*/

int pgtextCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[])
{
    float x,y;
    double d;
    unsigned long l3;
       
    if (argc<=3) {return TCL_ERROR;}

    Tcl_GetDouble(interp,argv[1],&d);
    x=(float)d;
    Tcl_GetDouble(interp,argv[2],&d);
    y=(float)d;
    l3=(unsigned long)strlen(argv[3]);
    
    pgtext_(&x,&y,argv[3],l3);
    return TCL_OK;

}
/*---------------------------------------------------------------------*/

int pgvsizCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[])
{    
    float x1,x2,x3,x4;
    double d;
    
    if (argc<=4) {return TCL_ERROR;}
    
    Tcl_GetDouble(interp,argv[1],&d);
    x1=(float)d;
    Tcl_GetDouble(interp,argv[2],&d);
    x2=(float)d;
    Tcl_GetDouble(interp,argv[3],&d);
    x3=(float)d;
    Tcl_GetDouble(interp,argv[4],&d);
    x4=(float)d;
    
    pgvsiz_(&x1,&x2,&x3,&x4);
   
    return TCL_OK;

}
/*---------------------------------------------------------------------*/

int pgwnadCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[])
{    
    float x1,x2,x3,x4;
    double d;
    
    if (argc<=4) {return TCL_ERROR;}
    
    Tcl_GetDouble(interp,argv[1],&d);
    x1=(float)d;
    Tcl_GetDouble(interp,argv[2],&d);
    x2=(float)d;
    Tcl_GetDouble(interp,argv[3],&d);
    x3=(float)d;
    Tcl_GetDouble(interp,argv[4],&d);
    x4=(float)d;
    
    pgwnad_(&x1,&x2,&x3,&x4);
   
    return TCL_OK;

}

/*---------------------------------------------------------------------*/

int pgpapCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[])
{    
    float x1,x2;
    double d;
    
    if (argc<=2) {return TCL_ERROR;}
    
    Tcl_GetDouble(interp,argv[1],&d);
    x1=(float)d;
    Tcl_GetDouble(interp,argv[2],&d);
    x2=(float)d;
    
    pgpap_(&x1,&x2);
   printf("ok %f %f\n ",x1,x2);
    return TCL_OK;

}

