#define USE_INTERP_RESULT 1
#include <tcl.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

/*   -------------    START HEADER FILE CONTENTS  ------------------         */

/* Cruise control build fails on fitsprep because it cannot find
   pgplot.h or pgplot_tcl.h whereas building manually can. So as a
   temporary measure I am pasting all the header data here (mnb) */

int pgcentCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);
int PgDemo1Cmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);
int GrexecCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);
int pgopenCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);
int pgclosCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);
int pglineCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);
int pgenvCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);
int pgsvpCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);
int pgqvpCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);
int pgqwinCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);
int pgswinCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);
int pglabCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);
int pggrayCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);
int pggraylistCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);
int pgscrCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);
int pgboxCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);              
int pgbinCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);               
int pgcontCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);              
int pgdrawCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);              
int pghistCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);
int pgmoveCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);
int pgmtxtCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);
int pgpixlCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);
int pgptCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);
int pgptxtCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);
int pgqchCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);
int pgqciCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);
int pgqcolCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);
int pgscfCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);
int pgsciCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);
int pgslsCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);
int pgslwCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);
int pgsubpCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);
int pgtextCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);
int pgvsizCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);
int pgwnadCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);
int pgpapCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);



int Grexec_Init(Tcl_Interp *interp);

int fortran_cmd_(int* n);



void ishell_(int* a,  int* n);
void  shell_(float* a,int* n);
void qsorti_(int* a,int* idx,int* n);


int  pgopen_wrapper_();
int  pgopen_(char* device,unsigned long l);
void pgclos_();
void pgenv_(float* xmin, float* xmax, float* ymin, float* ymax, int* n1, int* n2);
void pgline_(int* n, float* xpts, float* ypts);
void pgsvp_(float* x1, float* x2, float* y3, float* y2);
void pgqvp_(int* units, float* x1, float* x2, float* y3, float* y2);
void pgswin_(float* x1, float* x2, float* y1, float* y2);
void pgqwin_(float* x1, float* x2, float* y3, float* y2);
void pglab_(char* s1,char* s2,char* s3,unsigned long l1,unsigned long l2,unsigned long l3);
void pggray_(float* a,int* idim,int* jdim,int* i1,int* i2,int* j1,int* j2,float* fg, float* bg,float* tr);
void pgvstd_();
void pgscr_(int* i,float* x1,float*x2,float*x3);
void pgbox_(char *xopt,float *xtick,int *nxsub,char *yopt,float *ytick,int *nysub,unsigned long l1,unsigned long l2);
void pgbin_(int* i, float* x, float* d, int* l);
void pgcont_(float* a,int* idim,int* jdim,int* i1,int* i2,int* j1,int* j2,float* cont,int* nconts,float* tr);
void pgdraw_(float* x,float* y);
void pghist_(int* n, float* data, float* datamin,float*datamax,int* nbin, int* pgflag);
void pgmove_(float* x,float* y);
void pgmtxt_(char* side,float* disp,float* coord,float* fjust,char* txt,unsigned long l1,unsigned long l5);
void pgpixl_(float* a,int* idim,int* jdim,int* i1,int* i2,int* j1,int* j2,float* x1, float* x2, float* y1, float* y2);
void pgpt_(int* n, float* xpts, float* ypts,int* i);
void pgptxt_(float* x,float* y,float* a,float* f,char* txt,unsigned long l5);
void pgqch_();
void pgqci_();
void pgqcol_();
void pgscf_(int* i);
void pgsci_(int* i);
void pgsls_(int* i);
void pgslw_(int* i);
void pgsubp_(int* i1, int* i2);
void pgtext_(float* x,float* y,char* txt,unsigned long l3);
void pgvsiz_(float* x1,float* x2,float* x3,float* x4);
void pgwnad_(float* x1,float* x2,float* x3,float* x4);
void pgpap_(float* x1,float* x2);
int lmergeCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);
int ptr2dataCmd(ClientData clientData,
              Tcl_Interp *interp,
              int argc, char *argv[]);

/*   -------------    END HEADER FILE CONTENTS  ------------------         */


            
int Pgplot_tcl_Init(Tcl_Interp *interp) 
{
    Tcl_CreateCommand(interp,"lmerge",(Tcl_CmdProc *)lmergeCmd,
            (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL);

    Tcl_CreateCommand(interp,"ptr2data",(Tcl_CmdProc *)ptr2dataCmd,
            (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL);
            
    Tcl_CreateCommand(interp,"pgcent",(Tcl_CmdProc *)pgcentCmd,
            (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL);

    Tcl_CreateCommand(interp,"grexec",(Tcl_CmdProc *)GrexecCmd,
            (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL);

    Tcl_CreateCommand(interp,"pgopen",(Tcl_CmdProc *)pgopenCmd,
            (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL);

    Tcl_CreateCommand(interp,"pgclos",(Tcl_CmdProc *)pgclosCmd,
            (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL);

    Tcl_CreateCommand(interp,"pgline",(Tcl_CmdProc *)pglineCmd,
            (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL);

    Tcl_CreateCommand(interp,"pgqvp",(Tcl_CmdProc *)pgqvpCmd,
            (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL);

    Tcl_CreateCommand(interp,"pgsvp",(Tcl_CmdProc *)pgsvpCmd,
            (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL);

    Tcl_CreateCommand(interp,"pgswin",(Tcl_CmdProc *)pgswinCmd,
            (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL);
            
    Tcl_CreateCommand(interp,"pgqwin",(Tcl_CmdProc *)pgqwinCmd,
            (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL);

    Tcl_CreateCommand(interp,"pgenv",(Tcl_CmdProc *)pgenvCmd,
            (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL);

    Tcl_CreateCommand(interp,"pglab",(Tcl_CmdProc *)pglabCmd,
            (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL);

    Tcl_CreateCommand(interp,"pggray",(Tcl_CmdProc *)pggrayCmd,
            (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL);

    Tcl_CreateCommand(interp,"pggraylist",(Tcl_CmdProc *)pggraylistCmd,
            (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL);

    Tcl_CreateCommand(interp,"pgscr",(Tcl_CmdProc *)pgscrCmd,
            (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL);

    Tcl_CreateCommand(interp,"pgbox",(Tcl_CmdProc *)pgboxCmd,
            (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL);
            
    Tcl_CreateCommand(interp,"pgbin",(Tcl_CmdProc *)pgbinCmd,
             (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL);

    Tcl_CreateCommand(interp,"pgcont",(Tcl_CmdProc *)pgcontCmd,
             (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL);

    Tcl_CreateCommand(interp,"pgdraw",(Tcl_CmdProc *)pgdrawCmd,
             (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL);

    Tcl_CreateCommand(interp,"pghist",(Tcl_CmdProc *)pghistCmd,
             (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL);

    Tcl_CreateCommand(interp,"pgmove",(Tcl_CmdProc *)pgmoveCmd,
             (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL);

    Tcl_CreateCommand(interp,"pgmtxt",(Tcl_CmdProc *)pgmtxtCmd,
             (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL);

    Tcl_CreateCommand(interp,"pgpixl",(Tcl_CmdProc *)pgpixlCmd,
             (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL);

    Tcl_CreateCommand(interp,"pgpt",(Tcl_CmdProc *)pgptCmd,
             (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL);

    Tcl_CreateCommand(interp,"pgptxt",(Tcl_CmdProc *)pgptxtCmd,
             (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL);

    Tcl_CreateCommand(interp,"pgqch",(Tcl_CmdProc *)pgqchCmd,
             (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL);

    Tcl_CreateCommand(interp,"pgqci",(Tcl_CmdProc *)pgqciCmd,
             (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL);

    Tcl_CreateCommand(interp,"pgqcol",(Tcl_CmdProc *)pgqcolCmd,
             (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL);

    Tcl_CreateCommand(interp,"pgscf",(Tcl_CmdProc *)pgscfCmd,
             (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL);

    Tcl_CreateCommand(interp,"pgsci",(Tcl_CmdProc *)pgsciCmd,
             (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL);

    Tcl_CreateCommand(interp,"pgsls",(Tcl_CmdProc *)pgslsCmd,
             (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL);

    Tcl_CreateCommand(interp,"pgslw",(Tcl_CmdProc *)pgslwCmd,
             (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL);

    Tcl_CreateCommand(interp,"pgsubp",(Tcl_CmdProc *)pgsubpCmd,
             (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL);

    Tcl_CreateCommand(interp,"pgtext",(Tcl_CmdProc *)pgtextCmd,
             (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL);

    Tcl_CreateCommand(interp,"pgvsiz",(Tcl_CmdProc *)pgvsizCmd,
             (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL);

    Tcl_CreateCommand(interp,"pgwnad",(Tcl_CmdProc *)pgwnadCmd,
             (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL);

    Tcl_CreateCommand(interp,"pgpap",(Tcl_CmdProc *)pgpapCmd,
             (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL);

    Tcl_PkgProvide(interp,"pgplot_tcl","1.1");

    return TCL_OK;

}
